<?php

namespace App\Service;

use App\Entity\User;
use Doctrine\Bundle\DoctrineBundle\Attribute\AsDoctrineListener;
use Doctrine\ORM\Event\PostPersistEventArgs;
use Doctrine\ORM\Events;
use Doctrine\Persistence\Event\LifecycleEventArgs;


#[AsDoctrineListener(event: Events::postPersist)]
class RegisterListener
{
    public function __construct(protected Mattermost $mattermostSender)
    {
    }

    public function postPersist(PostPersistEventArgs $args): void
    {
        $entity = $args->getObject();
        if (!$entity instanceof User) {
            return;
        }

        $this->mattermostSender->sendNewUser($entity->getUserIdentifier());


    }
}